<?php

declare(strict_types=1);

namespace mirzaev\vk\robots;

use mirzaev\vk\robots\robot;

use mirzaev\accounts\vk as account;

/**
 * Робот-пользователь
 *
 * @package mirzaev\vk\robots
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */
final class user extends robot
{
    /**
     * Конструктор
     *
     * @param int|null $id Идентификатор
     * @param string|null $key Ключ
     */
    public function __construct(
        protected readonly int|null $id = null,
        protected readonly string|null $key = null
    ) {
        parent::__construct($id, $key);

        // Инициализация данных API
        $this->api['user_id'] = $this->id;
    }

    /**
     * Инициализация аккаунта
     *
     * @param account $account Аккаунт
     *
     * @return account|self Аккаунт при чтении или инстанцию робота при записи
     */
    public function account(account|null $account = null): account|self
    {
        if (isset($account)) {
            // Передан аккаунт

            if (isset($account->key)) {
                // Ключ инициализирован

                // Инициализация данных в настройках API
                $this->api()['access_token'] = $account->key;
            }
        }

        return parent::account($account);
    }
}
